class Edge {
  
  enum Kind { Directed, Undirected }

  public final Vertex start;
  public final Vertex end;
  public final int weight;
  public final Kind kind;

  public Edge(Vertex start, Vertex end) {
    this(start, end, Kind.Directed);
  }

  public Edge(Vertex start, Vertex end, Kind kind) {
    this(start, end, 0, kind);
  }

  public Edge(Vertex start, Vertex end, int weight, Kind kind) {
    this.start = start;
    this.end = end;
    this.weight = weight;
    this.kind = kind;
  }

  public boolean equals(Object o) {
    Edge e = (Edge) o;
    return (e.start == this.start && e.end == this.end)
        || ((e.start == this.end && e.end == this.start
            && (e.kind == Kind.Undirected || this.kind == Kind.Undirected)));
  }

  public int hashCode() {
    return start.hashCode() * end.hashCode();
  }
}
