import java.util.List;
import java.util.ArrayList;
import java.util.Stack;
import java.util.Queue;
import java.util.LinkedList;

class Graph {
  
  public final ArrayList vertices;
  public ArrayList edges;

  public Graph() {
    vertices = new ArrayList();
    edges = new ArrayList();
  }

  public void addVertex(Vertex vertex) {
    for (int i = 0; i < vertices.size(); i++) {
      Vertex v = (Vertex) vertices.get(i);
      if (vertex.equals(v)) {
        throw new IllegalArgumentException("Vertex already exists");
      }
    }
    if (vertex.isRoot && getRoot() != null) {
      throw new IllegalArgumentException("Root already exists");
    }
    vertices.add(vertex);
  }

  private Vertex getRoot() {
    for (int i = 0; i < vertices.size(); i++) {
      Vertex v = (Vertex) vertices.get(i);
      if (v.isRoot) {
        return v;
      }
    }
    return null;
  }

  public void addEdge(Edge edge) {
    checkVertex(edge.start);
    checkVertex(edge.end);
    for (int i = 0; i < edges.size(); i++) {
      Edge e = (Edge) edges.get(i);
      if (e.equals(edge)) {
        throw new IllegalArgumentException("Edge already exists");
      }
    }
    edges.add(edge);
  }

  private void checkVertex(Vertex vertex) {
    for (int i = 0; i < vertices.size(); i++) {
      Vertex v = (Vertex) vertices.get(i);
      if (v == vertex) {
        return;
      }
    }
    throw new IllegalArgumentException("Vertex does not exist");
  }
  
  public void makeDot(String filename) {
    Out.open(filename);
    Out.println(DotMakerGraph.makeDot(this));
    Out.close();
  }

  private Edge[] getEdges(Vertex vertex) {
    List result = new ArrayList();
    for (int i = 0;  i < edges.size(); i++) {
      Edge e = (Edge) edges.get(i);
      if (e.start == vertex) {
        result.add(e);
      } else if (e.kind == Edge.Kind.Undirected && e.end == vertex) {
        result.add(new Edge(e.end, e.start, e.weight, e.kind));
      }
    }
    return (Edge[]) result.toArray(new Edge[0]);
  }

  public void depthFirstSearch() {
    // TODO
    Stack stack = new Stack();
  }

  public void breadthFirstSearch() {
    // TODO
    Queue queue = new LinkedList();
  }

  public void makeMinimalSpanningTree(Vertex start) {
    // TODO
  }

  public void makeShortestPath(Vertex from, Vertex to) {
    // TODO
  }
}
